//-----------------------------------------------------------------------------
// Copyright (C) 2008  PROCEQ SA, CH-8603 Schwerzenbach
//-----------------------------------------------------------------------------
// Package                : PqRemoteDemoDLL
// Environment            : WIN32, MFC
// Tested on              : - Studio 2008 (V9)
//-----------------------------------------------------------------------------
// Source Code Management : $Workfile: PqRemoteDemoDLLDlg.h $
//                          $Revision: 4 $ $Date: 21.01.15 15:56 $ $NoKeywords: $
//-----------------------------------------------------------------------------
// Description:
//   A application dialog that demonstrates the useage of the PqRemote DLL 
//   under C++. This header declares the Dialog demonstrating the methods of 
//   the PqRemote DLL
//
//-----------------------------------------------------------------------------
// History (date author comment)
// -------
// 02-Oct-2008  MAP Initial
//-----------------------------------------------------------------------------


//=== Import ==================================================================
#pragma once
#include "afxwin.h"
#include "PqRemote.h"
#include "afxcmn.h"



//=== Class CPqRemoteDemoDLLDlg declaration ===================================
// Description:
//    This is the dialog class of the PqRemoteDemoDLL application. 
class CPqRemoteDemoDLLDlg : public CDialog
{
public:
  //--- Construction ---------------------------------------------------------
	CPqRemoteDemoDLLDlg( CWnd* pParent = NULL);	
  ~CPqRemoteDemoDLLDlg();

  // Dialog Data
	enum { IDD = IDD_PQREMOTEDEMODLL_DIALOG };

	protected:
  // DDX/DDV support
  virtual void DoDataExchange(CDataExchange* pDX);	


  //--- Implementation -------------------------------------------------------
protected:
	//--- Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
  afx_msg void OnBnClickedSendbutton();
  afx_msg void OnBnClickedReadbutton();
  afx_msg void OnBnClickedConnectbutton();
  afx_msg void OnBnClickedDisconnectbutton();
  afx_msg void OnBnClickedCheckread();
  afx_msg void OnBnClickedClearRead();
  afx_msg void OnTimer(UINT_PTR nIDEvent);
	DECLARE_MESSAGE_MAP()

public:
  //--- Handle to the icon
	HICON                   m_hIcon;
  //--- Holds the fixed space type font 
  CFont                   mFont;

  //--- Controls to the (parameter) fields of the dialog
  CEdit                   mSendCmdText;
  CEdit                   mCmdAnswer;
  CEdit                   mReadText;
  CEdit                   mReadTimeoutText;
  CString                 mReadBuffer;
  CButton                 mConnectButton;
  CButton                 mDisconnectButton;
  CButton                 mCheckScan;
  CButton                 mSendButton;
  CButton                 mReadButton;
  CButton                 mCheckRead;
  CComboBox               mComboInterface;
  CIPAddressCtrl          mIpAddress;
  
  //--- Handle to the PqRemote DLL
  HINSTANCE               mhLib;
  //--- Pointer to the methods in PqRemote
  PQ_LPCHECKCOMPATIBILITY mCheckCompatibility;
  PQ_LPCONNECTDEVICE      mConnect;
  PQ_LPDISCONNECTDEVICE   mDisconnect;
  PQ_LPSENDCMD            mSendCMD;
  PQ_LPREAD               mRead;

  //--- Handle to the Proceq Device
  unsigned long           mDeviceHandle;

  //--- Pointer to the timer needed for continuous read
  UINT_PTR                mTimerp;

  //--- Variables to some parameter fields
  long                    mReadTimeout;
  long                    mConnectTimeout;
  UINT                    mPort;

  BYTE mDeviceType;
  afx_msg void OnEnChangeDevicetype();
};
